% Converts either a range or vertices to evenly divided points

% For an m-dim'l input set, evenly divides the parallelogram defined by 2^m
% vertices into gx^m points. 


% V = [ V11 V12 ... V1m
%       V21 V22 ... V2m
%          |          | 
%       Vt1 Vt2 ... Vtm ]  in which t=2^m is the total # of vertices  
function [U]= Evenly(V,gx)  

m=size(V,2);
[Vmin, Vmax]= bounds(V);

for j=1:1:m
    totU(:,j)=[linspace(Vmin(j),Vmax(j),gx)];
end

Ind=[1:gx]';
for i=1:1:m-1
    Add=[]; Stk=[];
    for j=1:1:gx
        Add=[Add;ones(gx^i,1).*j];
        Stk=[Stk; Ind];
    end
    Ind=[Add Stk];
end

for i=1:1:gx^m
    for j=1:1:m
        U(i,j)=totU(Ind(i,j),j);
    end
end  
end


