% Here, the operability index is evaluated for one fixed design.
function OI=OI_SingleDesign(U,Y,DOS_rgs,gx,gxc,Type,Plot)

% --   Temporary   -- %

% [colmin,colmax] = bounds(U);
% U = rescale(U,'InputMin',colmin,'InputMax',colmax); clear colmin colmax
% 
% [DOS_rgs(1,:), DOS_rgs(2,:)]=bounds(DOS_rgs);
% DOS_rgs(3:end,:)=[];
% 
% Y=Y./DOS_rgs(2,:)
% DOS_rgs=DOS_rgs./DOS_rgs(2,:)
% ------------------- %

[AIS,AOS] = Triangulation(U,Y,gx); % Obtain input-output representation using simplices
DOS       = Pts2Prl(DOS_rgs,2);


 

switch Type
    case 'Subregions'
        [OI,DOS_subregions,pi,pii]=OI_subregions(AOS,DOS_rgs,gxc); % Estimate OI
       
    case 'Hypervolumes'
        [OI,REM] = OI_hypervol(AOS,DOS); % Estimate OI
end


% % % % Intersection of Polyhedra
n=1; ti=[];
for j=1:1:size(AOS,2)
        U_Out=PolyUnion('Set',[DOS AOS(j)]);        
        if(U_Out.isOverlapping==1)
            ti(n,1)=j; n=n+1;
        end   
end
 
tii(:,1)=1:1:size(AOS,2);
tii=setdiff(tii,intersect(tii,ti));


if strcmp(Plot,'Y')&&size(U,2)<=3
    switch Type
        case 'Subregions'
            PlotOI_subregions    
        case 'Hypervolumes'
            PlotOI_hypervolume

%     PlotOI
end

end



