% This function calculates the operability index based on the volume of the
% polyhedra inside DOS, as follows:
%
%       OI = #achieved_volumes/#volumes_DOS
%
% The DOS is divided into (c^3) parapelelepipeds considered for the
% calculcation of the operability index.

function [OI,DOS_subregions,pi,pii]=OI_subregions(AOS,DOS_rgs,gxc)

DOS_subregions  = Pts2Prl(DOS_rgs,gxc)
pi=[];


for i=1:1:size(DOS_subregions,2)
    if(sum(isEmptySet((AOS&DOS_subregions(i))))~=size(AOS,2))
        pi=[pi i]; 
    end
end
pii=1:1:size(DOS_subregions,2);
pii=setdiff(pii,intersect(pii,pi));

OI=100*size(pi,2)/size(DOS_subregions,2);

end
