function [optDIS,optDOS,status]=P2(fDIS,fDOS,nl_obj,obj,nl_eq,nl_ineq,Ae,be,A,b)

if ~isempty(nl_obj)&&~isempty(obj)
    error('Two selected objective functions');
    status='Error, both linear and nonlinear objective function filled';
    return;
end

r=size(fDIS,1);

% Check if points "survive" linear and nonlinear constraints
ti=[1:1:r]';
if ~isempty(Ae)&&~isempty(be)
    ti(any(Ae*[fDIS fDOS]'-be~=0,1)')=[];
    fDIS=fDIS(ti,:); fDOS=fDOS(ti,:); r=size(fDIS,1); ti=[1:1:r]';
end
if ~isempty(A)&&~isempty(b)&&~isempty(ti)
    ti(any(A*[fDIS fDOS]'-b>0,1)')=[];
    fDIS=fDIS(ti,:); fDOS=fDOS(ti,:); r=size(fDIS,1); ti=[1:1:r]';
end
if ~isempty(nl_eq)&&~isempty(ti)
    ti(arrayfun(@(r) nl_eq([fDIS(r,:) fDOS(r,:)]),[1:r]')~=0)=[];
    fDIS=fDIS(ti,:); fDOS=fDOS(ti,:); r=size(fDIS,1); ti=[1:1:r]';
end
if ~isempty(nl_ineq)&&~isempty(ti)
    ti(arrayfun(@(r) nl_ineq([fDIS(r,:) fDOS(r,:)]),[1:r]')>0)=[];
    fDIS=fDIS(ti,:); fDOS=fDOS(ti,:); r=size(fDIS,1); ti=[1:1:r]';
end

if ~isempty(ti) % The ones that "survived"
    if     ~isempty(nl_obj)
        [~,Min]=min(arrayfun(@(r) nl_obj([fDIS(r,:) fDOS(r,:)]),ti)); 
    elseif ~isempty(obj)
        [~,Min]=min(obj*[fDIS fDOS]');   
    else
        error('No objective function');
        status='Error, no objective function';
    end
  
    optDIS=fDIS(Min,:);
    optDOS=fDOS(Min,:);
    status='Optimal feasible point found';
else
    optDIS=[];
    optDOS=[];
    status='No feasible point';
end
end