function [AIS,AOS]= Pll(U,Y,gx) 

m=size(U,2); % Identify dimensionality
p=size(Y,2); % Identify output dimensionaly
[Umin,Umax]=bounds(U); % Obtain input ranges


for j=1:1:m
    totU(:,j)=[linspace(Umin(j),Umax(j),gx)]; 
end % Evenly divide points in each dim.

h(1,:)=totU(2,:)-totU(1,:); % Obtain step in each dim.

Ind=[1:2]'; % Increment at each bottom left corner (min)
            % to compose a //polytope 
for i=1:1:m-1
    Add=[]; Stk=[];
    for j=1:1:2
        Add=[Add;ones(2^i,1).*j]
        Stk=[Stk; Ind]
    end
    Ind=[Add Stk]
end
Ind=Ind-1

Ind_c=[1:gx-1]' %Indices of bottom left corners
for i=1:1:m-1
    Add=[]; Stk=[]
    for j=1:1:gx-1
        Add=[Add;ones((gx-1)^i,1).*j]
        Stk=[Stk; Ind_c]
    end
    Ind_c=[Add Stk]
end

for I=1:1:(gx-1)^m % Each row of Corner
    for i=1:1:2^m  % Each row of Ind
        for j=1:1:m  % Each coordinate
            V_U(i,j)=totU(Ind_c(I,j),j)+Ind(i,j).*h(1,j);
        end
        [~,b]=ismember(V_U(i,:),U,'rows');
        V_Y(i,:)=Y(b,:);
    end
    
    
    AIS(I)=Polyhedron('V',[V_U]);
    AOS(I)=Polyhedron('V',[V_Y]);

    clear V_U V_Y;
end

end
