figure
if ~isempty(ti)
    h1=plot(AIS(ti(1))    ,'Alpha',.33,'Color','red'); hold on
       plot(AIS(ti(2:end)),'Alpha',.33,'Color','red');
    legend([h1],{['AIS\capDIS:' num2str(size(ti,1)) ' tetrahedra']});
end
if ~isempty(tii)
    h2=plot(AIS(tii(1))    ,'Alpha',.33,'Color','blue'); hold on
       plot(AIS(tii(2:end)),'Alpha',.33,'Color','blue');
    if ~isempty(ti)
        legend([h1 h2],{['AIS\capDIS:' num2str(size(ti,1)) ' tetrahedra']...
        ['AIS-DIS:' num2str(size(tii,1)) ' tetrahedra']});
    else
        legend([h2],{['AIS-DIS:' num2str(size(tii,1)) ' tetrahedra']});
    end
end

xlabel('u_1'); ylabel('u_2'); if size(U,2)==3  zlabel('u_3');end
grid off; title('Available Input Set (AIS)');


figure
if ~isempty(pi)
    h1=plot(DOS_subregions(pi(1)),'Alpha', .4,'Color','gray'); hold on
       plot(DOS_subregions(pi(2:end)),'Alpha', .4,'Color','gray');
    lg1=['Achieved DOS: ' num2str(size(pi,2)) ' regions'];
end
if ~isempty(pii)
    h2=plot(DOS_subregions(pii(1)),'Alpha',0.2,'Color','gray','EdgeAlpha',.8,'LineStyle',':'); hold on
       plot(DOS_subregions(pii(2:end)),'Alpha',0.2,'Color','gray','EdgeAlpha',.8,'LineStyle',':')
    lg2=['Unachieved DOS: ' num2str(size(pii,2)) ' regions'];
end
if ~isempty(ti)
    h3=plot(AOS(ti(1))    ,'Alpha',.33,'Color','red');
       plot(AOS(ti(2:end)),'Alpha',.33,'Color','red');
    lg3=['AOS\capDOS:' num2str(size(ti,1)) ' tetrahedra'];
    if ~isempty(pi)&& isempty(pii) legend([h1 h3],{lg1,lg3}); end
    if  isempty(pi)&&~isempty(pii) legend([h2 h3],{lg2,lg3}); end
    if ~isempty(pi)&&~isempty(pii) legend([h1 h2 h3],{lg1 lg2,lg3}); end
end
if ~isempty(tii)
    h4=plot(AOS(tii(1))    ,'Alpha',.33,'Color','blue'); hold on
       plot(AOS(tii(2:end)),'Alpha',.33,'Color','blue');  
    lg4=['AOS-DOS:' num2str(size(tii,1)) ' tetrahedra'];
    if ~isempty(ti)
        if ~isempty(pi)&& isempty(pii) legend([h1 h3 h4],{lg1,lg3,lg4}); end
        if  isempty(pi)&&~isempty(pii) legend([h2 h3 h4],{lg2,lg3,lg4}); end
        if ~isempty(pi)&&~isempty(pii) legend([h1 h2 h3 h4],{lg1 lg2,lg3,lg4}); end
    else
        if ~isempty(pi)&& isempty(pii) legend([h1 h4],{lg1,lg4}); end
        if  isempty(pi)&&~isempty(pii) legend([h2 h4],{lg2,lg4}); end
        if ~isempty(pi)&&~isempty(pii) legend([h1 h2 h4],{lg1 lg2,lg4}); end  
    end
end

xlabel('y_1'); ylabel('y_2'); if size(Y,2)==3 zlabel('y_3'); end
grid off; title('Achievable Output Set (AOS)')

OItxt=['OI = ' num2str(size(pi,2)) '/' num2str(size(DOS_subregions,2)) ' = ' num2str(OI) '%'];
if size(Y,2)==2 text(Y(1,1),Y(1,2),OItxt);        end
if size(Y,2)==3 text(Y(1,1),Y(1,2),Y(1,3),OItxt); end 

