% ti and tii refer to polytopes (achieve and not achieve DOS, resp'ly)
% pi and pii refer to subregions (achieved and unaachieved sr's resp'ly)
dA=0.3; DA=0.1; eDA=0.2; fA=0.33; eA=1; 

f=figure
h=[]; lg={};

if ~isempty(ti)
    h1=plot(AIS(ti(1))    ,'Alpha',fA,'Color','red','EdgeAlpha',eA); hold on
       plot(AIS(ti(2:end)),'Alpha',fA,'Color','red','EdgeAlpha',eA);
    lg1=['AIS\capDIS: ' num2str(size(ti,1)) ' tetrahedra'];
    h=[h h1]; lg{1,end+1}=lg1;
end
if ~isempty(tii)
    h2=plot(AIS(tii(1))    ,'Alpha',fA,'Color','blue','EdgeAlpha',eA); hold on
       plot(AIS(tii(2:end)),'Alpha',fA,'Color','blue','EdgeAlpha',eA);
    lg2=['AIS-DIS: ' num2str(size(tii,1)) ' tetrahedra'];
    h=[h h2]; lg{1,end+1}=lg2;
end
   
legend(h,lg)
xlabel('u_1'); ylabel('u_2'); if size(U,2)==3  zlabel('u_3');end
grid off; title('Available Input Set (AIS)');


g=figure
h=[]; lg={};

if ~isempty(pi)
    h1=plot(DOS_subregions(pi(1)),'Alpha',dA,'Color','gray'); hold on
       plot(DOS_subregions(pi(2:end)),'Alpha',dA,'Color','gray');
    lg1=['Achieved DOS: ' num2str(size(pi,2)) ' subregions'];
    h=[h h1]; lg{1,end+1}=lg1;
end
if ~isempty(pii)
    h2=plot(DOS_subregions(pii(1)),'Alpha',DA,'Color','gray','EdgeAlpha',eDA,'LineStyle',':'); hold on
       plot(DOS_subregions(pii(2:end)),'Alpha',DA,'Color','gray','EdgeAlpha',eDA,'LineStyle',':');
    lg2=['Unachieved DOS: ' num2str(size(pii,2)) ' subregions'];
    h=[h h2]; lg{1,end+1}=lg2;
end
if ~isempty(ti)
    h3=plot(AOS(ti(1))    ,'Alpha',fA,'Color','red','EdgeAlpha',eA);
       plot(AOS(ti(2:end)),'Alpha',fA,'Color','red','EdgeAlpha',eA);
    lg3=['AOS\capDOS: ' num2str(size(ti,1)) ' tetrahedra'];
    h=[h h3]; lg{1,end+1}=lg3;
end
if ~isempty(tii)
    h4=plot(AOS(tii(1))    ,'Alpha',fA,'Color','blue','EdgeAlpha',eA); hold on
       plot(AOS(tii(2:end)),'Alpha',fA,'Color','blue','EdgeAlpha',eA);  
    lg4=['AOS-DOS: ' num2str(size(tii,1)) ' tetrahedra'];
    h=[h h4]; lg{1,end+1}=lg4;
end

legend(h,lg);

xlabel('y_1'); ylabel('y_2'); if size(Y,2)==3 zlabel('y_3'); end
grid off; title('Achievable Output Set (AOS)')

OItxt=['OI = ' num2str(size(pi,2)) '/' num2str(size(DOS,2)) ' = ' num2str(OI) '%'];
if size(Y,2)==2 text(Y(1,1),Y(1,2),OItxt);        end
if size(Y,2)==3 text(Y(1,1),Y(1,2),Y(1,3),OItxt); end 

