% Converts either a range,points or vertices to //polyhedra
% clear all; clc
% m=3; gxl=5
% Pts=[1 10 100;1 10 200;1 10 300;1 20 100;1 20 200;1 20 300;1 30 100
%      1 30 200;1 30 300;1 10 100;2 10 200;2 10 300;2 20 100;2 20 200
%      2 20 300;2 30 100;2 30 200;2 30 300;3 10 100;3 10 200;3 10 300
%      3 20 100;3 20 200;3 20 300;3 30 100;3 30 200;3 30 300]
     
function [Pll]= Pts2Prl(Pts,gxl) 

p=size(Pts,2); % Identify dimensionality
[Pmin,Pmax]=bounds(Pts); % Obtain ranges
for j=1:1:p
    totU(:,j)=[linspace(Pmin(j),Pmax(j),gxl)]; 
end % Evenly divide points in each dim.
h(1,:)=totU(2,:)-totU(1,:); % Obtain step in each dim.

gx=2;        %//polytopes has 2 vertices in each dim.
Ind=[1:gx]'; % Increment at each bottom left corner (min)
             % to compose a //polytope 
for i=1:1:p-1
    Add=[]; Stk=[];
    for j=1:1:gx
        Add=[Add;ones(gx^i,1).*j];
        Stk=[Stk; Ind];
    end
    Ind=[Add Stk];
end
Ind=Ind-1;

Ind_c=[1:gxl-1]'; %Indices of bottom left corners
for i=1:1:p-1
    Add=[]; Stk=[];
    for j=1:1:gxl-1
        Add=[Add;ones((gxl-1)^i,1).*j];
        Stk=[Stk; Ind_c];
    end
    Ind_c=[Add Stk];
end

for I=1:1:(gxl-1)^p % Each row of Corner
    for i=1:1:gx^p  % Each row of Ind
        for j=1:1:p  % Each coordinate
            V(i,j)=totU(Ind_c(I,j),j)+Ind(i,j).*h(1,j);
        end
    end 
    Pll(I)=Polyhedron('V',V);
    clear V;
end
end
